/*******************************************************************************
 * $Id: MaskedMemHash.h,v 1.3 2004/03/01 02:40:08 darling Exp $
 * This file is copyright 2002-2004 Aaron Darling.  All rights reserved.
 * Please see the file called COPYING for licensing, copying, and modification
 * rights.  Redistribution of this file, in whole or in part is prohibited
 * without express permission.
 ******************************************************************************/

#ifndef _MaskedMemHash_h_
#define _MaskedMemHash_h_

#include "libMems/MemHash.h"

/**
 * Finds matches that meet a particular sequence mask, e.g. 0b11111 for 5-way matches
 */
class MaskedMemHash : public MemHash{
public:
	MaskedMemHash();
	~MaskedMemHash(){};
	MaskedMemHash(const MaskedMemHash& mh);
	MaskedMemHash& operator=( const MaskedMemHash& mh );
	virtual MaskedMemHash* Clone() const;
	virtual void SetMask( uint64 seq_mask ){ this->seq_mask = seq_mask; }
protected:
	/**
	 * Can't find subsets when there is only one permitted sequence mask!
	 */
	virtual void FindSubsets(const Match& mhe, vector<Match>& subset_matches){};
	virtual boolean HashMatch(list<idmer>& match_list);
	uint64 seq_mask;
};

#endif //_MaskedMemHash_h_
